select
  an.numero as numero_matriz
  , an.nome as nome_matriz
  , (select count(*) from lactacao re where re.cdanimal = an.cdanimal) as num_ord_lact_avaliada
  , ultpar.data as data_ultimo_parto
  , (current_date - lac.dtinicio) as del_em_relacao_data_atual
  , (case when (catrep.cdcategoria = 3) then (diagp.dtpartoprovavel) else null end) as data_parto_previsto
  , (case when (catrep.cdcategoria = 3) then
            (diagp.dtpartoprovavel - cast((select valor from configuracao where upper(nome) = 'PERIODODESCANSO') as integer))
            else null end) as data_secagem_prevista
  , lac1.dtfim as dt_ultima_secagem
  , movs.descricao as motivo_ultima_secagem
  , ccs.dtanaliseleite as data_ultima_ccs
  , ccs.ccs as ultima_ccs
  , ccs2.dtanaliseleite as data_penultima_ccs
  , ccs2.ccs as penultima_ccs
  , le.dtleite as dt_ultimo_leite
  , le.pesototal as ultimo_leite  
  , cult1.data as dt_ultimo_cultivo
  , (case when (cult1.cdmicroorganismo1 is not null)
            then (select nome from microorganismo where cdmicroorganismo = cult1.cdmicroorganismo1) else null end) as Resultado_1_ultimo_cultivo
  , (case when (cult1.cdmicroorganismo2 is not null)
            then (select nome from microorganismo where cdmicroorganismo = cult1.cdmicroorganismo2) else null end) as Resultado_2_ultimo_cultivo
  , cult2.data as dt_penultimo_cultivo
  , (case when (cult2.cdmicroorganismo1 is not null)
            then (select nome from microorganismo where cdmicroorganismo = cult2.cdmicroorganismo1) else null end) as Resultado_1_penultimo_cultivo
  , (case when (cult2.cdmicroorganismo2 is not null)
            then (select nome from microorganismo where cdmicroorganismo = cult2.cdmicroorganismo2) else null end) as Resultado_2_penultimo_cultivo
  ,(case
    when pr1.CDPRODUTO is not null and pr2.CDPRODUTO is not null and pr3.CDPRODUTO is not null then pr1.nome || ' / ' || pr2.nome || ' / ' ||pr3.nome
    when pr1.cdproduto is not null and pr2.cdproduto is not null then pr1.nome || ' / ' || pr2.nome
    when pr1.cdproduto is not null then pr1.nome
    else NULL end) as tratamento_produto
  , (case
    when pa1.cdprincipioativo is not null and pa2.cdprincipioativo is not null and pa3.cdprincipioativo is not null then pa1.nome || ' / ' || pa2.nome || ' / ' ||pa3.nome
    when pa1.cdprincipioativo is not null and pa2.cdprincipioativo is not null then pa1.nome || ' / ' || pa2.nome
    when pa1.cdprincipioativo is not null then pa1.nome
    else NULL end) as tratamento_principio_ativo
from
  animal an
  join lactacao lac on lac.cdanimal = an.cdanimal and lac.dtfim is null
  join reproducao ultpar on ultpar.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao = 7 order by re.data desc)
  join categoria catrep on catrep.cdcategoria =
    (select sp.creprodutiva from sp_categoriaanimal(current_date, 'cdanimal = ' || an.cdanimal) sp)
  left join reproducao diagp on diagp.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.diagnostico = 'P' order by re.data desc)
  left join analiseleite ccs on ccs.cdanaliseleite =
   (select first 1 re.cdanaliseleite from analiseleite re where re.cdanimal = lac.cdanimal and re.dtanaliseleite >= lac.dtinicio and re.ccs > 0 order by re.dtanaliseleite desc)
  left join analiseleite ccs2 on ccs2.cdanaliseleite =
    (select first 1 re.cdanaliseleite from analiseleite re where re.cdanimal = lac.cdanimal and re.dtanaliseleite >= lac.dtinicio and re.ccs > 0 and re.dtanaliseleite < ccs.dtanaliseleite order by re.dtanaliseleite desc)
  left join leite le on le.cdleite =
    (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao order by re.dtleite desc)
  left join mamite cult1 on cult1.cdmamite =
    (select first 1 re.cdmamite from mamite re where re.cdanimal = lac.cdanimal and re.data >= lac.dtinicio and ((re.cdmicroorganismo1 is not null) or (re.cdmicroorganismo2 is not null)) order by re.data desc)
  left join mamite cult2 on cult2.cdmamite =
    (select first 1 re.cdmamite from mamite re where re.cdanimal = lac.cdanimal and re.data >= lac.dtinicio and ((re.cdmicroorganismo1 is not null) or (re.cdmicroorganismo2 is not null))
            and re.data < cult1.data order by re.data desc)
  left join lactacao lac1 on lac1.cdlactacao = (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtfim is not null
    order by re.dtinicio desc)
  left JOIN motivosecagem movs on movs.cdmotivosecagem = lac1.cdmotivosecagem
  left join mamite mt on mt.CDMAMITE =
    (select first 1 mt.CDMAMITE from mamite mt where mt.cdanimal = an.cdanimal and mt.data > lac.dtinicio and mt.cdtratamentobase is not null order by mt.data desc)
  LEFT join tratamentobase tb on tb.cdtratamentobase = mt.cdtratamentobase
  LEFT join produto pr1 on pr1.cdproduto = tb.cdproduto1
  LEFT join produto pr2 on pr2.cdproduto = tb.cdproduto2
  LEFT join produto pr3 on pr3.cdproduto = tb.cdproduto3
  LEFT join principioativo pa1 on pa1.cdprincipioativo = tb.cdprincipioativo1
  LEFT join principioativo pa2 on pa2.cdprincipioativo = tb.cdprincipioativo2
  LEFT join principioativo pa3 on pa3.cdprincipioativo = tb.cdprincipioativo3
where
  an.dtbaixa is NULL
  AND diagp.DTPARTOPROVAVEL IS NOT NULL
  AND catrep.cdcategoria = 3
  AND (diagp.dtpartoprovavel - cast((select valor from configuracao where upper(nome) = 'PERIODODESCANSO') as integer)) >=
---INFORMAR A DATA DE INCIO DAS PREVISES DE SECAGEM AQUI, CONFORME DESEJADO. MANTER O FORMATADO 'AAAA-MM-DD'.
  '2018-04-01'
  AND (diagp.dtpartoprovavel - cast((select valor from configuracao where upper(nome) = 'PERIODODESCANSO') as integer)) <=
---INFORMAR A DATA DE FIM DAS PREVISES DE SECAGEM AQUI, CONFORME DESEJADO. MANTER O FORMATADO 'AAAA-MM-DD'.
  '2018-05-01'
order by an.numordenado